        # If the emacs-el package has installed a pkgconfig file, use that to determine
# install locations and Emacs version at build time, otherwise set defaults.
%if %($(pkg-config emacs) ; echo $?)
%global emacs_version 22.1
%global emacs_lispdir  %{_datadir}/emacs/site-lisp
%global emacs_startdir %{_datadir}/emacs/site-lisp/site-start.d
%else
%global emacs_version  %{expand:%(pkg-config emacs --modversion)}
%global emacs_lispdir  %{expand:%(pkg-config emacs --variable sitepkglispdir)}
%global emacs_startdir %{expand:%(pkg-config emacs --variable sitestartdir)}
%endif

Name:           perl-SystemPerl
Version:        1.344
Release:        6%{?dist}
Summary:        SystemPerl Perl module

License:        LGPLv3+ or Artistic 2.0
Group:          Development/Libraries
URL:            http://www.veripool.org/wiki/systemperl
Source0:        http://www.cpan.org/authors/id/W/WS/WSNYDER/SystemPerl-%{version}.tar.gz

Patch0:         SystemPerl-1.344-example.patch

BuildRequires:  bison
BuildRequires:  coreutils
BuildRequires:  emacs
BuildRequires:  findutils
BuildRequires:  flex
BuildRequires:  make
BuildRequires:  perl
BuildRequires:  perl-devel
BuildRequires:  perl-generators
BuildRequires:  perl(Carp)
BuildRequires:  perl(ExtUtils::MakeMaker)
# Run-time:
BuildRequires:  perl(Class::Struct)
BuildRequires:  perl(Config)
BuildRequires:  perl(constant)
BuildRequires:  perl(DynaLoader)
BuildRequires:  perl(Exporter)
BuildRequires:  perl(File::Basename)
BuildRequires:  perl(File::Spec)
BuildRequires:  perl(FindBin)
BuildRequires:  perl(Getopt::Long)
BuildRequires:  perl(IO::File)
BuildRequires:  perl(lib)
BuildRequires:  perl(Pod::Usage) >= 1.34
BuildRequires:  perl(strict)
BuildRequires:  perl(vars)
BuildRequires:  perl(Verilog::Getopt) >= 2.211
BuildRequires:  perl(Verilog::Netlist) >= 3.200
BuildRequires:  perl(Verilog::Netlist::Subclass)
BuildRequires:  perl(warnings)
# Tests:
BuildRequires:  perl(Cwd)
BuildRequires:  perl(Test)

Requires:       perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:       perl(Pod::Usage) >= 1.34
Requires:       perl(Verilog::Getopt) >= 2.211
Requires:       perl(Verilog::Netlist) >= 3.200
Requires:       perl(warnings)
Requires:       emacs-filesystem >= %{emacs_version}

Obsoletes:      emacs-systemc-mode <= 1.344-1
Provides:       emacs-systemc-mode <= 1.344-1

# Filter under-specified dependencies
%global __provides_exclude %{?__provides_exclude:%{__provides_exclude}|}^perl\\(SystemC::Netlist::Module\\)$
%global __requires_exclude %{?__requires_exclude:%{__requires_exclude}|}^perl\\((Pod::Usage|Verilog::Getopt|Verilog::Netlist)\\)$

%description
SystemPerl is a version of the SystemC language. It is designed to expand
text so that needless repetition in the language is minimized. By using
sp_preproc, SystemPerl files can be expanded into C++ files at compile
time, or expanded in place to make them valid stand-alone SystemC files.

%package        devel
Summary:        Development files for %{name}
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}
# gcc for included standard library headers
Requires:       gcc

%description    devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.


%prep
%setup -q -n SystemPerl-%{version}

#Info: SystemC isn't in the environment
# Fedora will not shipped SystemC due to licensing issues
# SystemC patches for the user
#%%{__install} -d systemc_patches
#%%{__cp} -p patch*.diff systemc_patches

# Prepare Makefile for Chitlesh's private SystemC rpm
%patch0 -p1


%build

perl Makefile.PL INSTALLDIRS=vendor

make %{?_smp_mflags}

# Build emacs mode
emacs -batch -f batch-byte-compile systemc-mode.el
cat <<EOF > systemc-mode.el.site-start
(autoload 'systemc-mode "systemc-mode" "SystemC mode" t )
(setq auto-mode-alist (cons '("\\\\.sp\$" . systemc-mode) auto-mode-alist))
EOF


%install
make pure_install DESTDIR=$RPM_BUILD_ROOT

find $RPM_BUILD_ROOT -type f -name .packlist -exec rm -f {} \;
find $RPM_BUILD_ROOT -type f -name '*.bs' -size 0 -exec rm -f {} \;

%{_fixperms} $RPM_BUILD_ROOT/*


# -devel package and support for SystemC
%{__mkdir} -p $RPM_BUILD_ROOT%{_includedir}/%{name}
%{__install} -pm 0644 src/*.h $RPM_BUILD_ROOT%{_includedir}/%{name}
%{__install} -pm 0644 src/*.cpp $RPM_BUILD_ROOT%{_includedir}/%{name}


# Install emacs mode
%{__install} -d %{buildroot}%{emacs_startdir}
%{__install} -pm 0644 systemc-mode.el.site-start %{buildroot}%{emacs_startdir}/systemc-mode.el

%{__install} -d %{buildroot}%{emacs_lispdir}
%{__install} -pm 0644 systemc-mode.el systemc-mode.elc %{buildroot}%{emacs_lispdir}/


%check
make test


%files
%license COPYING
%doc Changes README
%doc example/
%{_bindir}/sp_includer
%{_bindir}/sp_makecheck
%{_bindir}/sp_preproc
%{_bindir}/vcoverage
%dir %{perl_vendorarch}/auto/SystemC
%dir %{perl_vendorarch}/auto/SystemC/Parser
%{perl_vendorarch}/auto/SystemC/Parser/Parser.so
%dir %{perl_vendorarch}/SystemC
%{perl_vendorarch}/SystemC/*
%{_mandir}/man?/*
%{emacs_lispdir}/systemc-mode.el*
%{emacs_startdir}/systemc-mode.el

%files devel
%{_includedir}/%{name}/


%changelog
* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.344-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Mon Nov 28 2016 Filipe Rosset <rosset.filipe@gmail.com> - 1.344-5
- Rebuilt to make perl-SystemPerl available in all archs

* Tue May 17 2016 Jitka Plesnikova <jplesnik@redhat.com> - 1.344-4
- Perl 5.24 rebuild

* Tue Feb 02 2016 Jitka Plesnikova <jplesnik@redhat.com> - 1.344-3
- Replace %%define by %%global

* Thu Oct 08 2015 Jitka Plesnikova <jplesnik@redhat.com> - 1.344-2
- Moved emacs sub-packages into main package (bug #1234551)

* Wed Sep 23 2015 Petr Pisar <ppisar@redhat.com> - 1.344-1
- 1.344 bump

* Thu Jun 18 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.336-14
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Fri Jun 05 2015 Jitka Plesnikova <jplesnik@redhat.com> - 1.336-13
- Perl 5.22 rebuild

* Thu Aug 28 2014 Jitka Plesnikova <jplesnik@redhat.com> - 1.336-12
- Perl 5.20 rebuild

* Sun Aug 17 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.336-11
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.336-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Sun Aug 04 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.336-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Sun Jul 21 2013 Petr Pisar <ppisar@redhat.com> - 1.336-8
- Perl 5.18 rebuild

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.336-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Fri Jul 20 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.336-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Wed Jun 27 2012 Petr Pisar <ppisar@redhat.com> - 1.336-5
- Perl 5.16 rebuild

* Fri Jan 13 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.336-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Mon Jun 20 2011 Marcela Mašláňová <mmaslano@redhat.com> - 1.336-3
- Perl mass rebuild

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.336-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Sun Nov 07 2010 Chitlesh GOORAH < chitlesh [AT] fedoraproject DOT org > 1.336-1
- new upstream release

* Thu Jul 01 2010 Chitlesh GOORAH < chitlesh [AT] fedoraproject DOT org > 1.335-1
- new upstream release

* Thu Mar 04 2010 Chitlesh GOORAH < chitlesh [AT] fedoraproject DOT org > 1.334-1
- new upstream release

* Tue Sep 15 2009 Chitlesh GOORAH < chitlesh [AT] fedoraproject DOT org > 1.331-1
- New upsteam release

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.330-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Wed Jul 15 2009 Chitlesh GOORAH < chitlesh [AT] fedoraproject DOT org > 1.330-1
- uint_t bug file #RHBZ 511400 -  Header Include Bug
- New upsteam release

* Thu Jun 11 2009 Chitlesh GOORAH < chitlesh [AT] fedoraproject DOT org > 1.321-1
- New upstream release

* Thu May 21 2009 Chitlesh GOORAH < chitlesh [AT] fedoraproject DOT org > 1.320-1
- New upstream release

* Sun Mar 29 2009 Chitlesh GOORAH < chitlesh [AT] fedoraproject DOT org > 1.311-1
- New upstream release

* Mon Mar 9 2009 Chitlesh GOORAH < chitlesh [AT] fedoraproject DOT org > 1.310-2
- Filtering Requires: and Provides

* Fri Mar 6 2009 Chitlesh GOORAH < chitlesh [AT] fedoraproject DOT org > 1.310-1
- new release

* Sun Dec 14 2008 Chitlesh GOORAH < chitlesh [AT] fedoraproject DOT org > 1.300-1
- Specfile autogenerated by cpanspec 1.77.
